// touch.JS V1.01 (C) yoshioka.teruo@nifty.com 2004-10-29
// touch.JS resets timestamp of files.
// Usage: touch [-acm] [+acm|-r agefile|-t [[CC]YY]MMDDhhmm[.SS]] files...

import System
import System.IO

try{
var CommandLineArgs : String[]=Environment.GetCommandLineArgs()
var files = new Array();
var to : int=0;
const toA : int=1;
const toC : int=2;
const toM : int=4;
var from : int=0;
const fromA : int=1;
const fromC : int=2;
const fromM : int=4;
const fromR : int=8;
const fromT : int=16;

for(var k=1;k<CommandLineArgs.Length;k++){
  var arg=CommandLineArgs[k];
  if(arg.charAt(0)=='-'){
    for(var j=1;j<arg.length;j++){
      switch(arg.charAt(j).toLowerCase()){
      case 'a':to|=toA;break;
      case 'c':to|=toC;break;
      case 'm':to|=toM;break;
      case 'r':from|=fromR;var ageFile : String=CommandLineArgs[++k];break;
      case 't':from|=fromT;var dateStr=CommandLineArgs[++k].split('.',2);break;
      default :
        throw('-Option Error');
      }
    }
  }
  else if(arg.charAt(0)=='+'){
    for(j=1;j<arg.length;j++){
      switch(arg.charAt(j).toLowerCase()){
      case 'a':from|=fromA;break;
      case 'c':from|=fromC;break;
      case 'm':from|=fromM;break;
      default :
        throw('+Option Error');
      }
    }
  }
  else{
    files.push(arg);
  }
}
//print('to'+to);
//print('from'+from);
//print('files'+files.length);
if(from & fromT){
//print('dateStr'+dateStr.length);
  var SS : int=dateStr.length==2 ? Convert.ToInt32(dateStr[1]) : 0 ;
  var timeStr : String=dateStr[0];
  var timeStrLen : int=timeStr.length;
  var mm : int=Convert.ToInt32(timeStr.slice(timeStrLen-2,timeStrLen));
  var hh : int=Convert.ToInt32(timeStr.slice(timeStrLen-4,timeStrLen-2));
  var DD : int=Convert.ToInt32(timeStr.slice(timeStrLen-6,timeStrLen-4));
  var MM : int=Convert.ToInt32(timeStr.slice(timeStrLen-8,timeStrLen-6));
  if(timeStrLen>10){
    var YY : int=Convert.ToInt32(timeStr.slice(timeStrLen-10,timeStrLen-8));
    var CC : int=Convert.ToInt32(timeStr.slice(timeStrLen-12,timeStrLen-10));
  }
  else if(timeStrLen>8){
    YY=Convert.ToInt32(timeStr.slice(timeStrLen-10,timeStrLen-8));
    CC=YY>=70 ? 19 : 20;
  }
  else{
    var year=new Date().getYear();
    YY=year%100;
    CC=Math.floor(year/100);
  }
  var toTime : DateTime=new Date(CC*100+YY,MM-1,DD,hh,mm,SS);
}
if(from&fromR){
  toTime=File.GetLastWriteTime(ageFile);
}
if(from==0){
  toTime=new Date();
}
//print(toTime);
if(to==0) to=toA|toC|toM;
//print('to'+to);
for(k=0;k<files.length;k++){
  var path=files[k];
//print(path);
  if(File.Exists(path)){
    touch(File,path);
  }
  else if(Directory.Exists(path)){
    touch(Directory,path);
  }
}
}catch(e){
  print(e);
}
function touch(obj,path){
//  print(path);
  switch(from&(fromA|fromC|fromM)){
  case fromA:toTime=obj.GetLastAccessTime(path);break;
  case fromC:toTime=obj.GetCreationTime(path);break;
  case fromM:toTime=obj.GetLastWriteTime(path);break;
  }
  if(to&toA){
    obj.SetLastAccessTime(path,toTime);
  }
  if(to&toC){
    obj.SetCreationTime(path,toTime);
  }
  if(to&toM){
    obj.SetLastWriteTime(path,toTime);
  }
}
